program chkpci;


uses newdelay, crt;

var
  fi	: text;
  s	: string;


  ven,
  dev,
  OEM,
  Sub,
  rev,
  x,
  p,
  i	: integer;


  t,
  f	: boolean;




function valdigits(d:string) : boolean;
begin
  p:=0;

  for i:=1 to length(d) do
  begin
    if (ord(d[i])>=ord('0')) and ((ord(d[i])<=ord('9'))) then inc(p);
    if (ord(d[i])>=ord('A')) and ((ord(d[i])<=ord('F'))) then inc(p);
  end;


  if p=length(d) then valdigits:=false else valdigits:=true;

end;




begin
  clrscr;
  writeln('CHKPCI Version 0.01');
  writeln;

  assign(fi,'PCIDEVS.TXT');
  reset(fi);

  ven:=0;
  dev:=0;
  oem:=0;
  sub:=0;
  rev:=0;
  x:=0;



  while not eof(fi) do
  begin
    readln(fi,s);
    t:=false;

    if length(s)=0 then t:=true;

    if not t then if s[1]=';' then t:=true;

    if not t then if s[1]='V' then
    begin
      f:=false;
      if s[2]<>#9 then f:=true;
      if s[7]<>#9 then f:=true;
      if valdigits(copy(s,3,4)) then f:=true;
      if f then writeln('Vendor Entry Error : ',copy(s,1,52));
      t:=true;
      inc(ven);
    end;

    if not t then if s[1]='D' then
    begin
      f:=false;
      if length(s)<8 then f:=true;
      if s[2]<>#9 then f:=true;
      if s[7]<>#9 then f:=true;
      if valdigits(copy(s,3,4)) then f:=true;
      if f then writeln('Device Entry Error : ',copy(s,1,52));
      t:=true;
      inc(dev);
    end;

    if not t then if s[1]='O' then
    begin
      f:=false;
      if length(s)<8 then f:=true;
      if s[2]<>#9 then f:=true;
      if s[7]<>#9 then f:=true;
      if valdigits(copy(s,3,4)) then f:=true;
      if f then writeln('OEM Entry Error    : ',copy(s,1,52));
      t:=true;
      inc(oem);
    end;

    if not t then if s[1]='S' then
    begin
      f:=false;
      if length(s)<8 then f:=true;
      if s[2]<>#9 then f:=true;
      if s[7]<>#9 then f:=true;
      if valdigits(copy(s,3,4)) then f:=true;
      if f then writeln('Subsys Entry Error : ',copy(s,1,52));
      t:=true;
      inc(sub);
    end;

    if not t then if s[1]='R' then
    begin
      f:=false;
      if length(s)<6 then f:=true;
      if s[2]<>#9 then f:=true;
      if s[5]<>#9 then f:=true;
      if valdigits(copy(s,3,2)) then f:=true;
      if f then writeln('Rev Entry Error    : ',copy(s,1,52));
      t:=true;
      inc(rev);
    end;

    if not t then if s[1]='X' then
    begin
      f:=false;
      if length(s)<12 then f:=true;
      if s[2]<>#9 then f:=true;
      if s[11]<>#9 then f:=true;
      if valdigits(copy(s,3,8)) then f:=true;
      if f then writeln('X Entry Error      : ',copy(s,1,52));
      t:=true;
      inc(x);
    end;




    if t=false then writeln('Unknown line   : ',copy(s,1,52));

  end;
  close(fi);


  writeln;

  writeln('Checked ',ven+dev+oem+sub+rev+x,' entries');
  writeln;
  writeln('Vendors : ',ven);
  writeln('Devices : ',dev);
  writeln('OEM IDs : ',oem);
  writeln('Sub IDs : ',sub);
  writeln('REV IDs : ',rev);
  writeln('X codes : ',x);

end.
